unit Unit1;

interface

uses
  Windows, Messages, SysUtils, {$IfNDef VER130} Variants, {$EndIf} Classes, Graphics, Controls, Forms,
  Dialogs, ieview, imageenview, ComCtrls, StdCtrls, Buttons, hyieutils, iexBitmaps, hyiedefs, iesettings, 
  iexLayers, iexRulers;

type
  TForm1 = class(TForm)
    ImageEnView1: TImageEnView;
    btnOpen: TBitBtn;
    btnCrop: TBitBtn;
    chkFit: TCheckBox;
    trkZoom: TTrackBar;
    lblZoom: TLabel;
    cmbGuides: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure btnCropClick(Sender: TObject);
    procedure chkFitClick(Sender: TObject);
    procedure cmbGuidesChange(Sender: TObject);
    procedure ImageEnView1DrawCanvas(Sender: TObject; ACanvas: TCanvas; ARect: TRect);
    procedure trkZoomChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
{$R ImageEnManifest.res}

const
  // Items of cmbGuides
  _cmbGuides_None     = 0;
  _cmbGuides_Thirds   = 1;
  _cmbGuides_DrawBox  = 2;

procedure TForm1.FormCreate(Sender: TObject);
begin
  cmbGuides.ItemIndex := _cmbGuides_None;
end;

procedure TForm1.btnOpenClick(Sender: TObject);
begin
 ImageEnView1.IO.LoadFromFile( ImageEnView1.IO.ExecuteOpenDialog('', '', false, 1, '') );
 ImageEnView1.MouseInteractGeneral := [miSelect];
 chkFitClick(nil);
end;

procedure TForm1.btnCropClick(Sender: TObject);
begin
  if ImageEnView1.Selected then
    ImageEnView1.Proc.CropSel
  else
    ShowMessage ('Select an area to crop with your mouse first!');
  ImageEnView1.Deselect;
end;

procedure TForm1.chkFitClick(Sender: TObject);
begin
  trkZoom.Enabled := not chkFit.Checked;
  lblZoom.Enabled := not chkFit.Checked;
  ImageEnView1.AutoShrink := chkFit.Checked;
  if chkFit.Checked then
  begin
    ImageEnView1.Fit;
    trkZoom.Position := Round(ImageEnView1.Zoom);
  end
  else
    ImageEnView1.Zoom := trkZoom.Position;
end;

procedure TForm1.cmbGuidesChange(Sender: TObject);
begin
  ImageEnView1.Invalidate();
end;


procedure TForm1.ImageEnView1DrawCanvas(Sender: TObject; ACanvas: TCanvas; ARect: TRect);
const
  Box_Width  = 100;
  Box_Height = 100;
  {}
  procedure _DrawLine(x1, y1, x2, y2: Integer); // bmp values
  begin
    ACanvas.Pen.Color := clGray;
    ACanvas.MoveTo( ImageEnView1.XBmp2Scr( x1 ), ImageEnView1.YBmp2Scr( y1 ) );
    ACanvas.LineTo( ImageEnView1.XBmp2Scr( x2 ), ImageEnView1.YBmp2Scr( y2 ) );
  end;
  {}
  procedure _DrawThirds();
  var
    selRect: TIERectangle;
  begin
    selRect := ImageEnView1.SelectedRect;

    // Horz Thirds
    _DrawLine( selRect.x, selRect.y + MulDiv( selRect.height, 1, 3 ),
               selRect.x + selRect.Width, selRect.y + MulDiv( selRect.height, 1, 3 ) );
    _DrawLine( selRect.x, selRect.y + MulDiv( selRect.height, 2, 3 ),
               selRect.x + selRect.Width, selRect.y + MulDiv( selRect.height, 2, 3 ) );

    // Vert Thirds
    _DrawLine( selRect.x + MulDiv( selRect.Width, 1, 3 ), selRect.y,
               selRect.x + MulDiv( selRect.Width, 1, 3 ), selRect.y + selRect.height );
    _DrawLine( selRect.x + MulDiv( selRect.Width, 2, 3 ), selRect.y,
               selRect.x + MulDiv( selRect.Width, 2, 3 ), selRect.y + selRect.height );
  end;
  {}
  procedure _DrawBox();
  var
    boxL, boxT, boxR, boxB: Integer;
  begin
    boxL := ImageEnView1.XBmp2Scr( ImageEnView1.IEBitmap.Width  div 2 - Box_Width  div 2 );
    boxT := ImageEnView1.YBmp2Scr( ImageEnView1.IEBitmap.Height div 2 - Box_Height div 2 );
    boxR := ImageEnView1.XBmp2Scr( ImageEnView1.IEBitmap.Width  div 2 + Box_Width  div 2 );
    boxB := ImageEnView1.YBmp2Scr( ImageEnView1.IEBitmap.Height div 2 + Box_Height div 2 );

    ACanvas.Pen.Color := clRed;
    ACanvas.Brush.Style := bsClear;
    ACanvas.Rectangle( boxL, boxT, boxR, boxB );
  end;
  {}
begin
  if ( cmbGuides.ItemIndex = _cmbGuides_Thirds ) and ( ImageEnView1.Selected ) then
    _DrawThirds()
  else
  if ( cmbGuides.ItemIndex = _cmbGuides_DrawBox ) and
     ( ImageEnView1.IEBitmap.Width > Box_Width ) and
     ( ImageEnView1.IEBitmap.Height > Box_Height ) and
     not ImageEnView1.IsEmpty2 then
    _DrawBox();
end;

procedure TForm1.trkZoomChange(Sender: TObject);
begin
  ImageEnView1.Zoom := trkZoom.Position;
end;

end.



